package com.capgemini.greenhouse.api;

import com.capgemini.greenhouse.model.RoomObject;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.validation.Valid;

/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.5).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2019-03-04T11:36:07.231Z[Europe/London]")
@Api(value = "room", description = "the room API")
public interface RoomApi {

    @ApiOperation(value = "Returns the last recorded humidity percentage of the room.", nickname = "roomHumidity", notes = "", response = Object.class, tags = {})
    @ApiResponses(value = {
            @ApiResponse(code = 200, message = "Information of the room's humidity", response = String.class),
            @ApiResponse(code = 400, message = "Invalid status value"),
            @ApiResponse(code = 200, message = "Unexpected error")})
    @RequestMapping(value = "/room/humidity",
            produces = {"application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Object> roomHumidity();


    @ApiOperation(value = "Returns the last recorded light in the room.", nickname = "roomLight", notes = "", response = Object.class, tags = {})
    @ApiResponses(value = {
            @ApiResponse(code = 200, message = "Information of the light lumens in the room.", response = Object.class),
            @ApiResponse(code = 400, message = "Invalid status value"),
            @ApiResponse(code = 200, message = "Unexpected error")})
    @RequestMapping(value = "/room/light",
            produces = {"application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Object> roomLight();


    @ApiOperation(value = "Returns the last recorded room temperature.", nickname = "roomTemperature", notes = "", response = Object.class, tags = {})
    @ApiResponses(value = {
            @ApiResponse(code = 200, message = "Temperature of the room.", response = Object.class),
            @ApiResponse(code = 400, message = "Invalid status value"),
            @ApiResponse(code = 200, message = "Unexpected error")})
    @RequestMapping(value = "/room/temperature",
            produces = {"application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Object> roomTemperature();


    @ApiOperation(value = "Updates the greenhouse room with new data", nickname = "updateRoom", notes = "", tags = {})
    @ApiResponses(value = {
            @ApiResponse(code = 405, message = "Invalid input"),
            @ApiResponse(code = 500, message = "Internal server error"),
            @ApiResponse(code = 503, message = "Service unavailable")})
    @RequestMapping(value = "/room/setup",
            consumes = {"application/json"},
            method = RequestMethod.POST)
    ResponseEntity<Void> updateRoom(@ApiParam(value = "room object", required = true) @Valid @RequestBody RoomObject body);

}
